CONFIG += ordered
TEMPLATE = subdirs

SUBDIRS = src tools

OTHER_FILES = configure debian/changelog Doxyfile FUTURE HACKING EXPECTFAIL

# =================================================================================================
# Pretend to build API documentation
# =================================================================================================

apidocs.target = docs/html/index.html
apidocs.commands = doxygen $$PWD/Doxyfile
apidocs.depends = Doxyfile src/*/*.cpp src/*/*.h
docs.depends = apidocs

QMAKE_EXTRA_TARGETS += apidocs docs

# =================================================================================================
# Generate HTML reports from a previous gcov run
# =================================================================================================

coverage-html.commands = $$PWD/tests/gcov-summary.sh lcov docs/coverage

QMAKE_EXTRA_TARGETS += coverage-html
QMAKE_CLEAN += gcov.analysis gcov.analysis.summary

# =================================================================================================
# Remove output of configure script on "make distclean"
# =================================================================================================

confclean.commands = $(DEL_FILE) $$TOP_BUILDDIR/.qmake.cache
distclean.depends = confclean

QMAKE_EXTRA_TARGETS += confclean distclean

# =================================================================================================
# Run configure script when building the project from tools like QtCreator
# =================================================================================================

isEmpty(CONFIGURED):system('$$PWD/configure')

confstamp.target = configure-stamp .qmake.cache
confstamp.commands = $$PWD/configure $$CONFIGURE_FLAGS
confstamp.depends = $$PWD/configure

QMAKE_EXTRA_TARGETS += confstamp
