/**************************************************************************
**
** This file is part of libqtcontacts-telepathy
**
** Copyright (c) 2011 Nokia Corporation and/or its subsidiary(-ies).
**
** Contact: Nokia Corporation (info@qt.nokia.com)
**
**
** GNU Lesser General Public License Usage
**
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this file.
** Please review the following information to ensure the GNU Lesser General
** Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
** If you have questions regarding the use of this file, please contact
** Nokia at info@qt.nokia.com.
**
**************************************************************************/

#include <QCoreApplication>
#include <QTextStream>

#include <TelepathyQt4/Debug>

#include <qct-toolclient.h>


static void usage(const QString &appName)
{
    QTextStream(stdout)
        << "This is a simple tool for listing telepathy account, contact roster list and remote contact search." << endl
        << "Usage: " << endl
        << appName << " -s <accountPath> <string>     Search people (accessible through <accountPath>) with profile info containing <string>." << endl
        << appName << " -l                            List all accounts' accountPaths." << endl;
}

int main(int argc, char **argv)
{
    QCoreApplication app(argc, argv);

    if (argc < 2) {
        usage(argv[0]);
        return EXIT_FAILURE;
    }
    Tp::registerTypes();
    Tp::enableWarnings(1);
    QCTToolClient client;
    QStringList args = app.arguments();
    if (QString::fromLatin1("-s") == args[1] && argc == 4) {
        client.search(args[2], args[3]);
    } else if (QString::fromLatin1("-l") == args[1]) {
        client.listAccounts();
    }

    app.exec();
    return EXIT_SUCCESS;
}
